Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_ko.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_ko.properties	(revision 36133)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_ko.properties	(revision 36134)
@@ -1,3 +1,4 @@
 #***** IMAGE URLS *****
+expand_image:interfaces/__INTERFACE_NAME__/images/expand.png
 collapse_image:interfaces/__INTERFACE_NAME__/images/collapse.png
 chapter_image:interfaces/__INTERFACE_NAME__/images/chapter.png
@@ -5,8 +6,16 @@
 book_image:interfaces/__INTERFACE_NAME__/images/book.png
 blank_image:interfaces/__INTERFACE_NAME__/images/blankImage.png
+float_toc_image:interfaces/__INTERFACE_NAME__/images/floattoc.png
+green_bug_image:interfaces/__INTERFACE_NAME__/images/GB.png
 
 #***** TEXT FRAGMENTS *****
+gsdl:Greenstone Digital Library Software
+gs3power:greenstone3 ì ê³µ
+error:Error:
 # the buttons
+debuginfo_b:Debug info
 # tool tips for the buttons
+debuginfo_tip:Debug ë³Žêž° ìµì
+ íì
 # months - used by replaceList in siteConfig. need to change to get from java..
 
@@ -27,4 +36,6 @@
  ë°ë ì»¬ë ì
  ëªšë  íìŽì§ì ê±žì³ ììµëë€.
+about.standarddescription:ìŽ ì»¬ë ì
+ìë {0-numdocs}ê°ì ë¬žìê° ììµëë€.
 about.standarddescriptiondays:ìŽ ì»¬ë ì
 ì {0-numdocs} ê±Žì ë¬žìë¥Œ í¬íšíë©° {1-date}ìŒ ì ì ë§ë šëììµëë€.
@@ -44,4 +55,30 @@
 # document page
 ##################
+doc.loading:loading
+doc.filter_pages:Filter pages
+doc.filter.pagenum:íìŽì§ ë²íž
+doc.filter.title:title
+doc.highlightTooltip:ê²ììŽ ê°ì¡° íì íì± ëë ë¹íì±
+doc.realisticBooksTooltip:ì€ì ì ìž ì±
+ ë³Žêž° íì± ëë ë¹íì±
+doc.zoomTooltip:íì€ ë³Žêž°ìì ìŽë¯žì§ íë/ì¶ì íì± ëë ë¹íì±
+doc.slideshowTooltip:ìŽë¯žì§ ì¬ëŒìŽëìŒ ë³Žêž°
+doc.floatingTooltip:ëª©ì°šë¥Œ íë©Ž ì€ë¥žìªœì ê³ ì 
+doc.expand_doc:ë¬žì íŒì¹êž°
+doc.collapse_doc:ê¹šì§ ë¬žì
+doc.document:ë¬žì
+doc.back_to_top:back to top
+doc.default_view:Default view
+doc.image_view:ìŽë¯žì§ë¡ ë³Žêž°
+doc.text_view:í
+ì€ížë¡ ë³Žêž°
+
+doc.map_nearby_docs:ê°ê¹ìŽ ìë ë¬žì íì
+doc.nearby_doc_tooltip:ìŽ ë¬žìì ì€ìì ë§ì°ì€ë¥Œ ê°ì žê°ëë€. íŽëŠ­íìë©Ž ë¬žìë¡ ìŽëí©ëë€.
+
+external.title:ìžë¶ ë§í¬
+external.text:íŽëŠ­í ë§í¬ë íì¬ ì íí ì»¬ë ì
+ì ìžë¶ì ììµëë€. ìŽ ë§í¬ë¥Œ ê³ì ë³Žê³  ì¶ê³  ëžëŒì°ì ê° ì¹ì ì¡ìžì€í  ì ìë ê²œì° ì¬êž°ë¡ {0-go-forward-link}í  ì ììµëë€. ê·žë ì§ ììŒë©Ž ëžëŒì°ì ì 'ë€ë¡' ë²íŒì ì¬ì©íì¬ ìŽì  ë¬žìë¡ ëìê°ëë€.
+external.go_forward:ììŒë¡
 
 #########################################################
@@ -53,7 +90,48 @@
 ##########################
 
+depositor.title:Depositor
+depositor.description:ìë ì»¬ë ì
+ì ë¬žì ì¶ê°
+depositor.select_collection:ì»¬ë ì
+ì ì ííìžì
+depositor.select_collection_option:-- ì»¬ë ì
+ ì í --
+depositor.no_valid_collection:ì»¬ë ì
+ ìì  ê¶íìŽ ììµëë€. ë€ë¥ž ì¬ì©ìë¡ ë¡ê·žìžíê±°ë êŽëŠ¬ììê² ë¬žìíìžì.
+
 #####################
 #  Document Editing #
 #####################
+de.error:ìì í  ì ììµëë€...
+de.error_unavailable:ì§êž ë¬žì ížì§ì ì¬ì©í  ì ììµëë€. ìì¹ŽìŽëž íŽëê° ìì ì ììµëë€.
+de.error_wrong_group:ìŽ ì»¬ë ì
+ì ížì§ ê¶íì ì§ë ê·žë£¹ êµ¬ì±ììŽ ìëëë€.
+de.error_contact_admin:êŽëŠ¬ì({0})ìê² ë¬žìíì­ìì€.
+de.rebuilding_collection:rebuilding collection
+de.no_changes:ë³ê²œì¬í­ìŽ ììµëë€.
+de.save:ì ì¥
+de.rebuild:Rebuild
+de.saverebuild:ì ì¥ ë° Rebuild
+de.extract_pages:ìŽ íìŽì§ë¥Œ ë¬žìë¡ ì¶ì¶
+de.visible_metadata:ë³ŽìŽë ë©íë°ìŽí°
+de.all_metadata:ëªšë
+de.add_new_metadata:ì ë©í ì ë³Ž ì¶ê°
+de.add_all_metadata:ëªšë ì²šê°
+de.no_meta_name_given:ì ë©íë°ìŽí° ìŽëŠìŽ ììµëë€.
+de.edit_metadata:ë©íë°ìŽí° ìì 
+de.edit_map_gps:GPS ì§ë ìì 
+de.hide_metadata:ë©íë°ìŽí° ìšêž°êž°
+de.hide_map_gps:GPS ì§ë ìšêž°êž°
+de.remove:ì ê±°
+de.edit_content:ëŽì© ìì 
+de.hide_editor:ì
+ë ¥êž° ìšêž°êž°
+de.save_changes:ì ì¥
+de.saving:ì ì¥
+de.enter_meta_name:ë©íë°ìŽí° ìŽëŠì ì
+ë ¥í ë€ì 'ì ë©íë°ìŽí° ì¶ê°'ë¥Œ íŽëŠ­íìžì.
+de.enter_meta_dropdown:ë©íë°ìŽí° ìŽëŠì ì
+ë ¥íê±°ë ìëìªœ íìŽíë¥Œ ì¬ì©íì¬ íëë¥Œ ì íí ë€ì 'ì ë©íë°ìŽí° ì¶ê°'ë¥Œ íŽëŠ­í©ëë€.
+de.top_level_menu:Top level menu
 ##################
 # authentication page
@@ -118,4 +196,6 @@
 db.doc_basket:ëê·ë©íž ë°êµ¬ë
 db.access_denied:ì ì ê±°ë¶
+db.no_collection_building:ì»¬ë ì
+ êµ¬ì¶ìŽ íì±íëìŽ ìì§ ììŒë¯ë¡ Greenstoneì ìŽ êž°ë¥ì ì¬ì©í  ì ììµëë€.
 
 ###################
@@ -127,47 +207,101 @@
 ###################
 
+error.title:ì! ë­ê° ìëª»ëìµëë€.
+error.recap_fail:Recaptcha ì€íš
+error.wrong_group:ìŽ ë¬žìë¥Œ ë³Œ ì ìë ê·žë£¹ìŽ ìëëë€.
+
 #####################
-#  Berry Baskets    #
+#  Favourites Basket    
 #####################
 
-berry.title:ë°êµ¬ë
-
-berry.full_view:ì ì²Ž ë³Žêž°
-berry.text_view:í
-ì€íž ë³Žêž°
-berry.email_view:Email
-berry.help:ë¬žìë¥Œ Drag & dropíì¬ ë¹ì ì ë°êµ¬ëì ëŽìŒìžì.
-berry.full:ì ì²Ž ë³Žêž° Â»
-berry.to:To:
-berry.cc:ì°žì¡°
-berry.bcc:BCC:
-berry.subject:ì ëª©
-berry.send:Send
-berry.url_only:URLë§ ë³Žêž°
-berry.url_and_metadata:URLê³Œ ë©íë°ìŽí ë³Žêž°
-berry.empty_basket:ë¹ì ì ë°êµ¬ëë í
-
- ë¹ììµëë€.
-berry.doc_name:ID
-berry.doc_title:ì ëª©
-berry.doc_collection:ìœë ì
+favourites.title:ìì£Œì°Ÿêž°
+
+favourites.full_view:ë€ ë³Žêž°
+favourites.text_view:í
+ì€ížë¡ ë³Žêž°
+favourites.email_view:Email
+favourites.full:ë€ ë³Žêž° Â»
+favourites.to:ìì ì:
+favourites.cc:ì°žì¡°:
+favourites.bcc:ìšì ì°žì¡°:
+favourites.subject:ì£Œì :
+favourites.send:ë°ì¡
+favourites.url_only:URLë§ ë³Žêž°
+favourites.url_and_metadata:URLê³Œ ë©íë°ìŽí° ë³Žêž°
+favourites.empty_basket:ì ì¥ë ìŠê²šì°Ÿêž°ê° ììµëë€.
+favourites.doc_name:ID
+favourites.doc_title:title
+favourites.doc_collection:ì»¬ë ì
 
-berry.doc_date:ë ì§
-berry.doc_root_title:ì ì²Ž ì ëª©
-berry.send_success:ë©ìŒ ë³ŽëŽêž° ì±ê³µ
-berry.send_fail:ë©ìŒ ë³ŽëŽêž° ìì­
-berry.invalid_to_address_empty:ì£Œì ìì­ìŽ ë¹ìŽ ììŒë©Ž ìë©ëë€.
-berry.invalid_to_address:ì£Œì ìì­ìë ìŽë©ìŒ ì£Œìë¥Œ ì
-ë ¥í©ëë€.
-berry.invalid_msg_body_empty:í
-ì€íž ìì­ìŽ ë¹ìŽ ìì ì ììµëë€.
-
-berry.delete_help:ê°ë³ ì¬í­ì ì­ì íë €ë©Ž ê·ž ììŽìœì íŽì§íµìŒë¡ ëëê·žíìžì.
-
-berry.select_all:ëªšë ì í
-berry.delete_selected:ì íë ê² ì­ì 
-berry.delete_all:ëªšë ì­ì 
+favourites.doc_date:ë ì§
+favourites.doc_root_title:main title
+favourites.send_success:ë°ì¡ ì±ê³µ
+favourites.send_fail:ë©ìŒ ë°ì¡ ì€íš
+favourites.invalid_to_address_empty:ë°ë ì¬ë ì£Œìë¥Œ ì ìŒìžì.
+favourites.invalid_to_address:ë°ë ì¬ë ì£Œì ê³µê°ìë ìŽë©ìŒ ì£Œìë¥Œ ë£ìµëë€.
+favourites.invalid_msg_body_empty:ë³žë¬ž í
+ì€íž íëë¥Œ ë¹ ê³µê°ìŒë¡ ë ì ììµëë€.
+
+favourites.delete_help:ê°ë³ í­ëª©ì ì­ì íë €ë©Ž ìŠê²šì°Ÿêž°\ ììŽìœì íŽëŠ­íì­ìì€.
+favourites.delete_else:ëë
+favourites.delete_all:Delete All
 ##################################
 # About Greenstone page
 ##################################
 
+gsdl.title:ê·žëŠ°ì€í€ì ëíŽ
+gsdl.brief:About the Greenstone software
+gsdl.main:ê·žëŠ°ì€í€ì ëì§íž ëìêŽ ì»¬ë ì
+ì ì ê³µíê³  ìë¡ìŽ ì»¬ë ì
+ì êµ¬ì¶í  ì ìë ìíížìšìŽ ì íêµ°ì
+ëë€. ì ë³Žë¥Œ ë€ë¬ìŽì ì¹ìŽë DVD ëë USB ëëŒìŽëžì ê°ì ìŽëì ë¯žëìŽì ê²ìíë ë€ìí ë°©ë²ì ì ê³µí©ëë€. ê·žëŠ°ì€í€ì University of Waikatoì New Zealand Digital Library Projectìì ì ìíê³  UNESCO ë° Human Info NGOì íë ¥íì¬ ë°°í¬ë©ëë€. GNU General Public License ì¡°ê±Žì ë°ëŒ {0-link}ìì ì¬ì©í  ì ìë ì€í ìì€ ìíížìšìŽì
+ëë€.
+gsdl.technical:êž°ì ì 
+gsdl.technical_desc:ë²ì , íë«íŒ ì§ì ë° ìíž ìŽì©ì±ê³Œ ê°ì êž°ì ì ìž ìžë¶ ì¬í­ì <a href="{0}">greenstone factsheet</a>ë¥Œ ì°žì¡°íìžì. ìíížìšìŽìë ë ê°ì§ ì£Œì ë²ì ìŽ ììµëë€. ìë Greenstone 2ê° ìê³ , ìì í ì¬ì€ê³ ë° ì¬êµ¬íì Greenstone 3ì
+ëë€. Greenstone 3ê° ì§ì ë°ì  ì€ìŽë ë€ìŽë¡ëë¥Œ ê¶í©ëë€. ìŽ íìŽì§ë Greenstone 3 ì€ì¹ì ìŒë¶ì
+ëë€.
+gsdl.customisation:Customisation
+gsdl.customisation_desc:Greenstoneì íì¥ì±ê³Œ ì¬ì©ì ì ìê° ê°ë¥íëë¡ í¹ë³í ì€ê³ëììµëë€. ìë¡ìŽ ë¬žì ë° ë©íë°ìŽí° íìì "plugins"(Perlìì)ìì ìì±í  ì ììµëë€. ì ì¬íê², "classifiers"ë¥Œ ìì±íì¬ ìë¡ìŽ ë©íë°ìŽí° íì êµ¬ì¡°ë¥Œ êµ¬íí  ì ììµëë€. ì¬ì©ì ìží°íìŽì€ ëªšìê³Œ ëëì XSLT í
+íëŠ¿, CSS ë° Javascriptë¥Œ ì¬ì©íì¬ ë³ê²œí  ì ììµëë€. Java, C++, Perl ë° C++ì ìì€ ìœëë ìì ìŽ ê°ë¥íê³  ì¡ìžì€í  ì ììµëë€. ììží ëŽì©ì <a href="{0}">Greenstone Wiki</a>ë¥Œ ì°žì¡°íìžì.
+gsdl.documentation:ë¬žìí
+gsdl.documentation_desc:ëšê³ë³ <a href="{1}">tutorials</a>ì í¬íšíì¬ <a href="{0}">Greenstone Wiki</a>ìì Greenstone ìíížìšìŽì ëí êŽë²ìí ì€ëª
+ì ë³Œ ì ììµëë€.
+gsdl.support:ì§ì
+gsdl.support_desc:ìžìŽë³ ë©ìŒë§ ëŠ¬ì€íž, ì§ì­ ì§ì ê·žë£¹ ë° êž°í ëŠ¬ìì€ì ëí ììží ëŽì©ì <a href="{0}">ì§ì</a> íìŽì§ë¥Œ ì°žì¡°íìžì.
+gsdl.bugs:Bugs
+gsdl.bugs_desc:ì í¬ë ìŽ ìíížìšìŽê° ì ìëíëì§ íìžíê³  ì¶ìµëë€. ë²ê·žê° ë°ê²¬ëë©Ž <a href="{0}">Greenstone Users Mailing List</a>ë¡ ìë €ì£Œìêž° ë°ëëë€.
+gsdl.greenstone_stone:ê·žëŠ°ì€í€ì (ìŽ íë¡ê·žëšì²ëŒ) ëŽì§ëëìì ìì°ëë ë³Žìì
+ëë€. ì íµì ìž ë§ì€ëŠ¬ ì¬íììë ìŽê²ì ê°ì¥ ëìŽ íê°íê³  ì»ê³ ì íììµëë€. ì íµì ìŒë¡ ìíŒ ëë ìëª
+ë ¥ì ìì²ìž ììŽë£šìë¥Œ í¡ìíê³  ë³Žì í  ì ìë€ê³  ì¬ê²šì§ë ìŽê²ì ê³µê³µ ëì§íž ëìêŽ íë¡ì ížì ì í©í ìì§ìŽ ë©ëë€. ê·ž êŽíì ìì ì ëíëŽê³ , í¬ê³Œì±ì ì ì§ì, ëšëšíšì ì©êž°ë¥Œ ëë¬ëŽë©°, ë ì¹Žë¡­ê² ë ì ìžìž ì ìë ì±ì§ì ì ìë¥Œ ìì§í©ëë€.
+gsdl.toki_about1:2000ë
+ 11ì, ë§ì€ëŠ¬ë¶ì¡±ì ëŽì§ëë ëì§íž ëìêŽì <a href="{0}">Niupepa Collection</a>ê³Œ ê°ì taonga(ë³Žë¬Œ)ì ëí ì€ìí ìì
+ì ê°ì¬íêž° ìíŽ  toki pou tangata(greenstone adze)ë¥Œ ì ë¬Œíìµëë€. Tokië NgÄti WhÄtuaì Te Rarawa ííµì Bernard Makoareê° ì¡°ê°íìµëë€.
+
+##################
+# Cookie Consent Manager
+##################
+ccm.Popup_Title:ì¿ í€ë¥Œ ì¬ì©í©ëë€!
+ccm.Popup_Description:Greenstoneì ì ì í ìëì ìíŽ íì ì¿ í€ë¥Œ ì¬ì©í©ëë€.
+ccm.Popup_OpenAdvancedManager:ë ë³Žêž°
+ccm.Popup_AcceptAllCookies:ììì
+ccm.Popup_AcceptNecessaryCookies:ëªšë ê±°ë¶
+
+ccm.Manager_Title:ì¿ í€ ëì êŽëŠ¬ì
+ccm.Manager_Description:Greenstoneì ë°ë¥ž ìëì ìíŽ íì ì¿ í€ë¥Œ ì¬ì©í©ëë€. ëì€ì êž°ë³ž ì€ì  íìŽì§ìì ì¿ í€ êŽëŠ¬ìë¥Œ ë³Œ ì ììµëë€.
+ccm.Manager_SaveSettingsButton:ë«êž°
+ccm.Manager_AcceptAllButton:ëªšë ì¹ìž
+ccm.Manager_AcceptNecessaryButton:ëªšë ê±°ë¶
+ccm.Manager_CloseButton:Close
+ccm.Manager.CookieTableHeaders_Name:ìŽëŠ
+ccm.Manager.CookieTableHeaders_Provider:ì ê³µì
+ccm.Manager.CookieTableHeaders_Expiration:ë§ë£
+ccm.Manager.CookieTableHeaders_Description:ì€ëª
+
+ccm.Manager.CookieTable_EndOfSessionExpiration:ìžì
+ ì¢
+ë£
+ccm.Manager.RequiredCookies_Title:íì ì¿ í€
+ccm.Manager.RequiredCookies_Description:ìŽ ì¿ í€ë€ì GreenstoneìŽ ë°ë¥Žê² ìëíëë¡ íë ë° íìì ì
+ëë€.
+ccm.Manager.RequiredCookies.JSESSIONID_Description:GreenstoneìŽ ë¡ê·žìž ìí, ì íí ìžìŽ, ì¬ìŽíž ì€ì  ë° ìŠê²šì°Ÿêž° ë°êµ¬ëë¥Œ ì ì§íëë¡ íì©í©ëë€.
+ccm.Manager.RequiredCookies.supportsXSLT_Description:ê·íì ëžëŒì°ì ê° íŽëŒìŽìžíž ìž¡ XSLT ë³íì ì§ìíëì§ ì¬ë¶ë¥Œ ì ì ìëë¡ ì¹ìží©ëë€.