Index: main/trunk/gli/src/org/greenstone/gatherer/cdm/SearchIndexManager.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/cdm/SearchIndexManager.java	(revision 36173)
+++ main/trunk/gli/src/org/greenstone/gatherer/cdm/SearchIndexManager.java	(revision 36174)
@@ -69,4 +69,5 @@
       this.nip_edit_index_key = "CDM.IndexManager.Edit_Index";
       this.nip_source_label_key = "CDM.IndexManager.Source";
+      this.nip_source_tooltip_key = "CDM.IndexManager.Source_Tooltip";
       this.nip_add_index_button_key = "CDM.IndexManager.Add_Index";
       this.nip_add_index_tooltip_key = "CDM.IndexManager.Add_Index_Tooltip";
@@ -307,5 +308,5 @@
 	     private JButton select_all_button;
 	     private JButton select_none_button;
-	     private JButton add_all_button;
+          //private JButton add_all_button;
 	    
 	    private boolean mgpp_enabled = false;
@@ -332,12 +333,12 @@
               }
             });
-            if (existing_index == null && mgpp_enabled) {
-              button_pane.setLayout(new GridLayout(2,3,5,0));
-              JPanel tmp = new JPanel();
-              tmp.setComponentOrientation(Dictionary.getOrientation());
-              button_pane.add(tmp);
-            } else {
+            // if (existing_index == null && mgpp_enabled) {
+            //   button_pane.setLayout(new GridLayout(2,3,5,0));
+            //   JPanel tmp = new JPanel();
+            //   tmp.setComponentOrientation(Dictionary.getOrientation());
+            //   button_pane.add(tmp);
+            // } else {
               button_pane.setLayout(new GridLayout(2,2,5,0));
-            }
+              //}
             
             select_all_button = new GLIButton(Dictionary.get("CDM.IndexManager.Select_All"), Dictionary.get("CDM.IndexManager.Select_All_Tooltip"));
@@ -365,10 +366,10 @@
             button_pane.add(select_none_button);
 
-            if (existing_index == null && mgpp_enabled) {
-              add_all_button = new GLIButton(Dictionary.get("CDM.IndexManager.Add_All"), Dictionary.get("CDM.IndexManager.Add_All_Tooltip"));
-              add_all_button.setEnabled(true);
-              add_all_button.addActionListener(new AddAllIndexActionListener());
-              button_pane.add(add_all_button);
-            }
+            // if (existing_index == null && mgpp_enabled) {
+            //   add_all_button = new GLIButton(Dictionary.get("CDM.IndexManager.Add_All"), Dictionary.get("CDM.IndexManager.Add_All_Tooltip"));
+            //   add_all_button.setEnabled(true);
+            //   add_all_button.addActionListener(new AddAllIndexActionListener());
+            //   button_pane.add(add_all_button);
+            // }
 
             button_pane.add(add_or_replace_button);
@@ -493,40 +494,40 @@
 	    
 
-	    /** add all sources as separate indexes (fields).  */
-	    private class AddAllIndexActionListener
-		implements ActionListener {
-
-		public void actionPerformed(ActionEvent event) {
-		    ArrayList all_sources = source_list.getAll();
-		    all_sources.add(0, StaticStrings.TEXT_STR);
-		    ArrayList new_sources = new ArrayList();
-		    for(int i = 0; i < all_sources.size(); i++) {
-			Object source = all_sources.get(i);
-
-			// Create new index
-			new_sources.clear();
-			new_sources.add(source);
-			Index index = new Index(new_sources);
-			if(!index_model.contains(index)) {
-			    // Determine the metadatum value
-			    String name = source.toString();
-			    if(name.startsWith(StaticStrings.EXTRACTED_NAMESPACE) && name.indexOf(StaticStrings.NS_SEP, StaticStrings.EXTRACTED_NAMESPACE.length()) == -1) {
-				name = name.substring(StaticStrings.EXTRACTED_NAMESPACE.length());
-			    }
-			    // Create new metadatum
-			    CollectionMeta metadatum = new CollectionMeta(StaticStrings.STOP_CHARACTER + index.getID());
-			    metadatum.setValue(name);
-			    name = null;
-			    // Assign new index
-			    addIndex(index, metadatum);
-			}
-			source = null;
-			index = null;
-		    }
-		    new_sources = null;
-		    new_index_prompt.dispose();
+	    // /** add all sources as separate indexes (fields).  */
+	    // private class AddAllIndexActionListener
+	    //     implements ActionListener {
+
+	    //     public void actionPerformed(ActionEvent event) {
+	    //         ArrayList all_sources = source_list.getAll();
+	    //         all_sources.add(0, StaticStrings.TEXT_STR);
+	    //         ArrayList new_sources = new ArrayList();
+	    //         for(int i = 0; i < all_sources.size(); i++) {
+	    //     	Object source = all_sources.get(i);
+
+	    //     	// Create new index
+	    //     	new_sources.clear();
+	    //     	new_sources.add(source);
+	    //     	Index index = new Index(new_sources);
+	    //     	if(!index_model.contains(index)) {
+	    //     	    // Determine the metadatum value
+	    //     	    String name = source.toString();
+	    //     	    if(name.startsWith(StaticStrings.EXTRACTED_NAMESPACE) && name.indexOf(StaticStrings.NS_SEP, StaticStrings.EXTRACTED_NAMESPACE.length()) == -1) {
+	    //     		name = name.substring(StaticStrings.EXTRACTED_NAMESPACE.length());
+	    //     	    }
+	    //     	    // Create new metadatum
+	    //     	    CollectionMeta metadatum = new CollectionMeta(StaticStrings.STOP_CHARACTER + index.getID());
+	    //     	    metadatum.setValue(name);
+	    //     	    name = null;
+	    //     	    // Assign new index
+	    //     	    addIndex(index, metadatum);
+	    //     	}
+	    //     	source = null;
+	    //     	index = null;
+	    //         }
+	    //         new_sources = null;
+	    //         new_index_prompt.dispose();
 		
-		}
-	    }
+	    //     }
+	    // }
     
 	    private class AllFieldsBoxListener