Index: main/trunk/gli/classes/dictionary.properties
===================================================================
--- main/trunk/gli/classes/dictionary.properties	(revision 35664)
+++ main/trunk/gli/classes/dictionary.properties	(revision 36181)
@@ -85,4 +85,6 @@
 CDM.BuildTypeManager.lucene:Lucene
 CDM.BuildTypeManager.lucene_Description:Lucene was developed by the Apache Software Foundation. It handles field and proximity searching, but only at a single level (e.g. complete documents or individual sections, but not both). Therefore document and section indexes for a collection require two separate index files. It provides a similar range of search functionality to MGPP with the addition of single-character wildcards, range searching and sorting of search results by metadata fields. It was added to Greenstone to facilitate incremental collection building, which MG and MGPP can't provide.
+CDM.BuildTypeManager.solr:SOLR
+CDM.BuildTypeManager.solr_Description:SOLR is a web server friendly version of the Lucene Indexing tool by Apache. It provides the same set of functionality as Lucene, but is typically quicker to respond to individual queries due to holding key indexing structures in memory and caching results. SOLR provides all the features that Lucene does, such as incremental collection building, field and proximity searching, range searching and sorting of search results.  SOLR additionally provides faceted browsing of search results - i.e. filtering the results based on metadata values, and GPS-based proximity search.
 CDM.BuildTypeManager.Current_Type:Indexer in use: {0}
 CDM.BuildTypeManager.Change:Change...
@@ -106,5 +108,5 @@
 CDM.DatabaseTypeManager.gdbm_Description: GDBM (or GNU Database Manager) is a simple flat-file database engine which Greenstone uses as the default database for new collections.
 CDM.DatabaseTypeManager.jdbm:JDBM
-CDM.DatabaseTypeManager.jdbm_Description: JDBM (or Java Database Manager) is essentially a Java implementation of GDBM. Consider using this database engine combined with the Lucene indexer if you are wanting to create a pure Java run-time.
+CDM.DatabaseTypeManager.jdbm_Description: JDBM (or Java Database Manager) is essentially a Java implementation of GDBM. Consider using this database engine combined with a Lucene or SOLR indexer if you are wanting to create a pure Java run-time.
 CDM.DatabaseTypeManager.sqlite:SQLITE
 CDM.DatabaseTypeManager.sqlite_Description: SQLite is a simple relational database engine. It can be used in Greenstone to provide experimental advanced searching features that are not possible with the other database engines. To enable these features add "sqlform" to the list of SearchTypes in the Format Features section of the Format tab. 
@@ -165,5 +167,5 @@
 CDM.HelpButton_Tooltip:Open up the GLI help for this screen
 CDM.IndexManager.Add_Index:Add Index
-CDM.IndexManager.Add_Index_Tooltip:Add the specified index
+CDM.IndexManager.Add_Index_Tooltip:Add a search index on the (combined) specified index
 CDM.IndexManager.Allfields_Index:Add combined searching over all assigned indexes (allfields)
 CDM.IndexManager.Default_Index_Indicator:[Default Index]
@@ -172,19 +174,20 @@
 CDM.IndexManager.Level:Indexing level:
 CDM.IndexManager.Level_Tooltip:Textual unit on which index is based
-CDM.IndexManager.Add_All:Add All
-CDM.IndexManager.Add_All_Tooltip:Add a separate index for every source
-CDM.IndexManager.Edit_Index:Edit Index
-CDM.IndexManager.Edit_Index_Tooltip:Modify the selected index
-CDM.IndexManager.New_Index:New Index
-CDM.IndexManager.New_Index_Tooltip:Add a new index
-CDM.IndexManager.Remove_Index:Remove Index
-CDM.IndexManager.Remove_Index_Tooltip:Remove the selected index
+CDM.IndexManager.Edit:Edit
+#CDM.IndexManager.Edit_Index:Edit Index
+CDM.IndexManager.Edit_Button_Tooltip:Modify the selected index
+CDM.IndexManager.New:New
+#CDM.IndexManager.New_Index:New Index
+CDM.IndexManager.New_Button_Tooltip:Add a new search index
+CDM.IndexManager.Remove:Remove
+#CDM.IndexManager.Remove_Index:Remove Index
+CDM.IndexManager.Remove_Button_Tooltip:Remove the selected index
 CDM.IndexManager.Replace_Index:Replace Index
-CDM.IndexManager.Replace_Index_Tooltip:Update the selected index
+CDM.IndexManager.Replace_Index_Tooltip:Update the selected index with the selected fields
 CDM.IndexManager.Select_All:Select All
 CDM.IndexManager.Select_All_Tooltip:Select all index sources
 CDM.IndexManager.Select_None:Select None
 CDM.IndexManager.Select_None_Tooltip:Deselect all index sources
-CDM.IndexManager.Set_Default:Set Default Index
+CDM.IndexManager.Set_Default:Set Default
 CDM.IndexManager.Set_Default_Tooltip:Make the selected index the default index
 CDM.IndexManager.Source:Include in index:
@@ -192,4 +195,30 @@
 CDM.IndexManager.Text_Source:Full text
 CDM.IndexManager.Text_Source_Tooltip:Include the full text of the documents in the index
+CDM.SortFieldManager.Title:Assigned Sort Fields
+CDM.SortFieldManager.Add:Add Sort Field
+CDM.SortFieldManager.Add_Tooltip::Add the specified fields as a single sort field - used for sorting search results
+CDM.SortFieldManager.Replace:Replace Sort Field
+CDM.SortFieldManager.Replace_Tooltip:Replace the selected sort field with the new specification
+CDM.SortFieldManager.New:New Sort Field
+CDM.SortFieldManager.Edit:Edit Sort Field
+CDM.SortFieldManager.Source:Include in sort field
+CDM.SortFieldManager.Source_Tooltip:The metadata elements to sort search results by
+CDM.SortFieldManager.New_Button_Tooltip:Add a new field for sorting search results 
+CDM.SortFieldManager.Edit_Button_Tooltip:Modify the selected sort field
+CDM.SortFieldManager.Remove_Button_Tooltip:Remove the selected sort field
+CDM.SortFieldManager.Default_Sort_Indicator:[Default sort field]
+CDM.SortFieldManager.Set_Default_Tooltip:Make the selected sortfield the default field for sorting search results
+CDM.FacetManager.Title:Assigned Facets
+CDM.FacetManager.Add:Add Facet
+CDM.FacetManager.Add_Tooltip:Add the (combined) specified fields as a facet for filtering search results
+CDM.FacetManager.Replace:Replace Facet
+CDM.FacetManager.Replace_Tooltip: Replace the selected facet with the specified fields
+CDM.FacetManager.New:New Facet
+CDM.FacetManager.Edit:Edit Facet
+CDM.FacetManager.Source:Include in facet
+CDM.FacetManager.Source_Tooltip:The metadata elements to filter search results by
+CDM.FacetManager.New_Button_Tooltip:Add a new metadata field, or 'facet', to filter search results
+CDM.FacetManager.Edit_Button_Tooltip:Modify the selected facet
+CDM.FacetManager.Remove_Button_Tooltip:Remove the selected facet
 CDM.IndexingManager.Accent_fold:Accent fold
 CDM.IndexingManager.Accent_fold_Tooltip:Generate an accent-folded index, which enables searching for words ignoring accents.
@@ -249,4 +278,6 @@
 CDM.SearchMetadataManager.Type_index:Index
 CDM.SearchMetadataManager.Type_level:Level
+CDM.SearchMetadataManager.Type_sort:Sort Field
+CDM.SearchMetadataManager.Type_facet:Facet
 CDM.SearchMetadataManager.Type_partition:Partition
 CDM.SearchMetadataManager.Type_language:Language Partition
@@ -299,4 +330,5 @@
 CDM.TranslationManager.Translation:Translated Text
 CDM.TranslationManager.Translation_Tooltip:Enter the translation of the string here
+CDM.TranslationManager.Type_general:General
 CDM.DepositorMetadataManager.Warning:At least one metadata element should be selected.
 #*******************