Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOCONF.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOCONF.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOCONF.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=autoconf
+version=-2.70
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOMAKE.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOMAKE.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/AUTOMAKE.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=automake
+version=-1.16.4
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/CMAKE.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/CMAKE.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/CMAKE.sh	(revision 36201)
@@ -0,0 +1,25 @@
+#!/bin/bash
+
+package=cmake
+version=-3.22.4
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+export OPENSSL_ROOT_DIR=$GEXTVIDEO/buuild-srcpack/packages/openssl-1.1.1m
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/FFMPEG-NG.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/FFMPEG-NG.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/FFMPEG-NG.sh	(revision 36201)
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+package=ffmpeg
+
+# If changing this version number, don't forget to update FFKEYFRAME.sh
+#version=-jul21-2007
+version=-0.10.2
+
+
+
+progname=$0
+
+##source ../../cascade-make/bin/script/test-setup.bash
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+if [ -d $package ] ; then
+  echo "Moving $package -> $package$version"
+  /bin/mv $package $package$version
+fi
+
+
+##     "--enable-shared --enable-static --enable-swscaler \
+##      --extra-ldflags=-L$prefix/lib/ \
+
+opt_run_configure $force_config $auto_config $package $version "$prefix" \
+     "--disable-shared --enable-static  \
+      --enable-libmp3lame --enable-gpl --enable-nonfree \
+      --enable-libvorbis \
+      --enable-libfaac  \
+      --disable-ffserver \
+      --extra-ldflags='-L$prefix/lib/ -static'\
+      --extra-cflags=-I$prefix/include"
+
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBNUMA.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBNUMA.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBNUMA.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=numactl
+version=-2.0.13
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBTOOL.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBTOOL.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/LIBTOOL.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=libtool
+version=-2.4.7
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/M4.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/M4.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/M4.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=m4
+version=-1.4.19
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
Index: /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/NASM.sh
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/NASM.sh	(revision 36201)
+++ /gs2-extensions/video-and-audio/trunk/src/build-srcpack/packages/CASCADE-MAKE/NASM.sh	(revision 36201)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=nasm
+version=-2.15.05
+
+progname=$0
+
+source ../../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTVIDEO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version .tar.xz
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+